#include <cmath>
#include <iostream>
#include <stdio.h>

#define INF 10000

extern"C"
{
   void mvtdst_(int * N, int * df, double lower [],double uppper [], double infin [],double correl [],double delta [],int * maxpts,double * abseps, double * releps, double * error, double * value, int * inform);
}

/*
void cov2cor(Matrix & sigma, Matrix & corr)
{
   for(int i=0;i<sigma.rows;i++)
   {
      for(int j=i;j<sigma.cols;j++)
      {
	 if(i==j)
	    corr[i][j] = 1.0;
	 else 
	 {
	    corr[i][j]=corr[j][i] 
	       = sigma[i][j]/(sqrt(sigma[i][i])*sqrt(sigma[j][j]));
	 }
      }
   }
}
*/

void cov2cor(double sigma [2][2], double corr [2][2],int n)
{
   for(int i=0;i<n;i++)
   {
      for(int j=i;j<n;j++)
      {
         if(i==j)
            corr[i][j] = 1.0;
         else 
         {
            corr[i][j]=corr[j][i] 
               = sigma[i][j]/(sqrt(sigma[i][i])*sqrt(sigma[j][j]));
         }
      }
   }
}

int main ()
{
   int n = 2;
   double mean [2] = {0,0};
   double lower [2] = {1,1};
   double upper [2] = {INF,1};
   double sigma [2][2];
   double corr [2][2];
   sigma[0][0]= sigma[1][1] =2;
   sigma[0][1] = sigma[1][0] = 1;
   double delta [2] = {0,0};

   double infin [2];
   double corrF [1];

   cov2cor(sigma,corr,n);

   //fill in the corrF array to pass to Fortran
   for(int i=0;i<n;i++)
   {
	   for(int j=0;i<n;j++)
	   {
		   if(j<i)
		   {
			   int k = j+(i-2)*(i-1);
			   corrF[k] = corr[i][j]; 
		   } 
	   }
   }

   //recalculate lower and upper limit
   for(int i=0;i<n;i++)
   {
	   if(lower[i] != INF && lower[i] != INF)
	   {
		   lower[i] = (lower[i]-mean[i])/sqrt(sigma[i][i]);
	   }

	   if(upper[i] != INF && upper[i] != INF)
	   {
		   upper[i] = (upper[i]-mean[i])/sqrt(sigma[i][i]);
	   }

	   if(lower[i]==-INF && upper[i] ==INF) 
	   {
		   infin[i] = -1;
	   }
	   else if(lower[i]==-INF)
	   {
		   infin[i] = 0;
	   }
	   else if(upper[i]==INF) 
	   {
		   infin[i] = 1;
	   }
	   else 
	   {
		   infin[i] =2;
	   }

	   if(lower[i] ==-INF)
	   {
		   lower[i] =0;
	   }

	   if(upper[i] ==INF)
	   {
		   upper[i] =0;
	   }
   }

   int N = n;
   int df = 0;
   int maxpts = 25000;
   double abseps = 0.001;
   double releps = 0.0;
   double error =0.0;
   double value = 0.0;
   int inform = 0;

   mvtdst_(& n, & df, lower,upper,infin,corrF,delta, & maxpts, & abseps, & releps, & error, & value, & inform);

   printf("pvalue is %g.\n",value);
}

